'use strict';

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _ = require('../');

var _Login = require('./components/Login');

var _Login2 = _interopRequireDefault(_Login);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

test('login form submits', function () {
  var fakeUser = { username: 'jackiechan', password: 'hiya! 🥋' };
  var handleSubmit = jest.fn();

  var _render = (0, _.render)(_Login2.default, { props: { onSubmit: handleSubmit } }),
      updateState = _render.updateState,
      getByLabelText = _render.getByLabelText,
      getByText = _render.getByText;

  var usernameNode = getByLabelText('username');
  var passwordNode = getByLabelText('password');
  var submitButtonNode = getByText('submit');

  // Act - this is waiting on an issue in @vue/test-utils to allow v-model to be updated by
  // changes to DOM elements

  // Simulate.change(usernameNode, fakeUser.username)
  // Simulate.change(passwordNode, fakeUser.password)
  updateState(fakeUser);

  // NOTE: in jsdom, it's not possible to trigger a form submission
  // by clicking on the submit button. This is really unfortunate.
  // So the next best thing is to simulate a submit on the form itself
  // then ensure that there's a submit button.
  _.Simulate.click(submitButtonNode);

  // Assert
  expect(handleSubmit).toHaveBeenCalledTimes(1);
  expect(handleSubmit).toHaveBeenCalledWith(fakeUser);
  // make sure the form is submittable
  expect(submitButtonNode.type).toBe('submit');
});