'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Simulate = exports.wait = exports.render = undefined;

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _testUtils = require('@vue/test-utils');

var _vuex = require('vuex');

var _vuex2 = _interopRequireDefault(_vuex);

var _vueRouter = require('vue-router');

var _vueRouter2 = _interopRequireDefault(_vueRouter);

var _waitForExpect = require('wait-for-expect');

var _waitForExpect2 = _interopRequireDefault(_waitForExpect);

var _Simulate = require('./Simulate');

var _Simulate2 = _interopRequireDefault(_Simulate);

var _queries = require('./queries');

var queries = _interopRequireWildcard(_queries);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function render(TestComponent) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$props = _ref.props,
      props = _ref$props === undefined ? null : _ref$props,
      _ref$store = _ref.store,
      store = _ref$store === undefined ? null : _ref$store,
      _ref$routes = _ref.routes,
      routes = _ref$routes === undefined ? null : _ref$routes;

  var localVue = (0, _testUtils.createLocalVue)();
  var vuexStore = null;
  var router = null;

  if (store) {
    localVue.use(_vuex2.default);
    vuexStore = new _vuex2.default.Store(store);
  }

  if (routes) {
    localVue.use(_vueRouter2.default);
    router = new _vueRouter2.default(routes);
  }

  var wrapper = (0, _testUtils.mount)(TestComponent, {
    localVue: localVue,
    router: router,
    store: vuexStore,
    propsData: (0, _extends3.default)({}, props),
    attachToDocument: true
  });

  var wrapperHelpers = (0, _entries2.default)(queries).reduce(function (helpers, _ref2) {
    var _ref3 = (0, _slicedToArray3.default)(_ref2, 2),
        key = _ref3[0],
        fn = _ref3[1];

    helpers[key] = fn.bind(null, wrapper);
    return helpers;
  }, {});

  return (0, _extends3.default)({
    unmount: function unmount() {
      return wrapper.destroy();
    },
    isUnmounted: function isUnmounted() {
      return wrapper.vm._isDestroyed;
    },
    html: function html() {
      return wrapper.html();
    },
    updateProps: function updateProps(_) {
      return wrapper.setProps(_);
    },
    updateState: function updateState(_) {
      return wrapper.setData(_);
    }
  }, wrapperHelpers);
}

function wait() {
  var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};

  var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref4$timeout = _ref4.timeout,
      timeout = _ref4$timeout === undefined ? 4500 : _ref4$timeout,
      _ref4$interval = _ref4.interval,
      interval = _ref4$interval === undefined ? 50 : _ref4$interval;

  return (0, _waitForExpect2.default)(callback, timeout, interval);
}

exports.render = render;
exports.wait = wait;
exports.Simulate = _Simulate2.default;